
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>OLTP类系统数据结转最佳实践 / iVAN</title>

    <meta name="description" content="OLTP类系统数据结转最佳实践 本文着重介绍了京东数据结转平台的技术架构,及OLTP类系统数据结转最佳实践,探讨解决大数据背景下的数据结转问题. 一. 背景介绍 业务系统在长期运行的过程中会积累大量的数据,这些数据有些是需要长期保存的,例如一些订单数据,有些只需要短期保存,例如一些日志信息.业务数据一般都会有一个生命周期,生命周期内的我们叫生产数据,生命周期之外(即业务已经关闭)的叫历史数据,我们这里提到的数据结转,指的是将需要长期保存的历史数据从生产库迁移到历史库(转),而将需要短期保存的数据定期删除(结). 我们已经进入了">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">OLTP类系统数据结转最佳实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文着重介绍了京东数据结转平台的技术架构，及OLTP类系统数据结转最佳实践，探讨解决大数据背景下的数据结转问题。</p>
<p><strong>一、 背景介绍</strong></p>
<p>业务系统在长期运行的过程中会积累大量的数据，这些数据有些是需要长期保存的，例如一些订单数据，有些只需要短期保存，例如一些日志信息。业务数据一般都会有一个生命周期，生命周期内的我们叫生产数据，生命周期之外(即业务已经关闭)的叫历史数据，我们这里提到的数据结转，指的是将需要长期保存的历史数据从生产库迁移到历史库(转)，而将需要短期保存的数据定期删除(结)。</p>
<p>我们已经进入了大数据时代，但在OLTP类系统中，关系型数据库依然占据主导地位，在关系型数据库中，如果不及时进行数据结转，会严重影响系统的性能。</p>
<p>关系型数据库单机容量有限，因此业界普遍的做法是进行垂直分库和水平分片，一些大型互联网企业由于业务量庞大，仅分片的集群规模就能达到上千节点，再加上分库的集群，规模非常巨大。传统的数据归档方法往往针对单库操作，难以处理如此大规模集群的数据归档。</p>
<p>同时，在大型互联网企业，每日的数据增长量非常大，数据结转的频率远大于传统行业，这些行业的IT系统往往是7*24小时不间断提供服务，而且全天24小时的并发量都很大，因此数据结转操作必须尽量减少对生产库的性能影响。</p>
<p>为此，我们自主研发了数据结转平台，以解决大数据背景下的数据结转问题。</p>
<p><strong>二、 技术架构</strong></p>
<p>2.1 设计要点</p>
<p>(1)尽量减少对生产库的影响</p>
<p>数据结转操作没有复杂的业务逻辑，因此对数据库性能的影响主要体现在IO方面，减少对生产库的影响，最主要的就是减少对生产库的IO操作。目前我们采用的方案是通过从库查询数据，将数据插入历史库，然后再从主库中删除，如图1数据结转逻辑图所示，将查询的IO操作转嫁到从库上，可以大大减轻对主库的影响。为了保障数据库的高可用，业内基本都采用了主从部署模式，因此这个方案具有很高的通用性。</p>
<p><a href="http://s1.51cto.com/wyfs02/M00/8F/92/wKiom1jloN3Atk1bAABIzZzoQho696.png-wh_651x-s_1228734229.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvOTIvd0tpb20xamxvTjNBdGsxYkFBQkl6WnpvUWhvNjk2LnBuZy13aF82NTF4LXNfMTIyODczNDIyOS5wbmc=.jpg"></a></p>
<p>图1 数据结转逻辑图</p>
<p>(2)支持分库分片集群</p>
<p>我们希望数据结转平台的配置足够简单并且易于理解。在和用户的沟通过程中，我们发现他们最强烈的需求就是分库分片集群的数据结转。传统的单机数据结转操作可以抽象描述为：将数据库实例A中表B的历史数据结转到历史库C，用户的配置主要有4个元素：生产库实例A、结转表B、结转条件和历史库。对于大规模的分库分片集群规模，如果采用传统单机数据结转的配置方式，每一个数据库实例都要配置4个元素，配置量非常大。</p>
<p>在我们的方案中，按照图2所示对数据库集群进行划分，将主库、从库、历史库作为一个结转单元，对于分片的数据库集群，表结构相同，我们将其作为一个分组，对于分库的集群，表结构不同则划分为不同的分组。用户进行配置的时候不是面向一个数据库实例，而是面向一个分组，数据结转操作抽象为：结转分组X中表B的历史数据，用户的配置元素有3个：分组X、结转表B和结转条件。分组信息仅需配置一次。这样大大简化了用户的配置工作。</p>
<p>(3)支持水平扩展</p>
<p>由于数据库集群规模较大，数据结转平台应该具备水平扩展能力。我们采用的方案是将数据结转最核心的组件定时任务和数据库操作(数据结转执行器)独立出来，进行分布式部署。如下图3所示，</p>
<p><a href="http://s2.51cto.com/wyfs02/M00/8F/92/wKiom1jloPLSN-RtAABsRsSR8A8940.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvOTIvd0tpb20xamxvUExTTi1SdEFBQnNSc1NSOEE4OTQwLnBuZw==.jpg"></a></p>
<p>图2 数据库集群模型</p>
<p>配置中心为用户的入口，用户通过配置中心定义数据结转任务，任务的关键属性包括：触发条件、执行条件、目标分组等，配置中心将结转任务分发给代理程序，同时对代理程序的执行状态进行监控。结转任务的触发条件配置在代理程序中的定时任务中，而执行条件和目标分组则作为数据结转执行器的执行参数。通过水平扩展代理程序，我们对更多的数据库进行结转。</p>
<p><a href="http://s1.51cto.com/wyfs02/M00/8F/90/wKioL1jloQbQZPlgAAAoVsSvQ9Q660.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvOTAvd0tpb0wxamxvUWJRWlBsZ0FBQW9Wc1N2UTlRNjYwLnBuZw==.jpg"></a></p>
<p>图3 数据结转组件关系图</p>
<p>2.2 总体架构</p>
<p>综合上面提到的3个设计要点，我们得到图4所示的总体架构，需要特别说明的是，对于水平分片的分组，我们采用的是多线程结转，对于不同结转单元不存在数据共享问题，所以无需考虑并发锁等问题。</p>
<p><strong>三、 一些经验总结</strong></p>
<p>a) 配置中心与代理程序之间的信息同步</p>
<p><a href="http://s4.51cto.com/wyfs02/M01/8F/92/wKiom1jloRWgepGJAAD3xcBU3Jo791.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEYvOTIvd0tpb20xamxvUldnZXBHSkFBRDN4Y0JVM0pvNzkxLmpwZw==.jpg"></a></p>
<p>图4 数据结转总体架构图</p>
<p>配置中心和代理程序在我们的方案中被设计为一种松耦合结构：在系统的运行过程中，代理程序宕机不会影响配置中心的运行，同样配置中心短暂的不可用也不会影响代理程序的运行。松耦合结构可以大大增强系统的可用性，而且配置中心、代理程序升级的时候不会影响整个系统的正常运行。</p>
<p>为了实现松耦合的结构，配置中心与代理程序之间的信息同步我们都是采用的异步处理，比如配置中心向代理程序分发结转任务，实际处理的时候我们采用的是拉的方式，而不是推的方式，我们在配置中心和代理程序之间维持了一个心跳，心跳的内容是代理程序负载的所有结转任务的校验码(该校验码在代理程序向配置中心发送心跳信息时由配置中心计算)，当代理程序发现从配置中心得到的校验码和本地校验码不同时，则说明用户对结转任务进行了修改(包括新增、修改、删除)，此时代理程序主动向配置中心发起同步结转任务的请求。这样做的好处是，代理程序在发生宕机重启后，会自动进行任务的同步。</p>
<p>b) 进度可视化</p>
<p>结转任务的进度在我们的方案中是实时汇总到配置中心的，我们称为进度可视化，代理程序通过一个独立的线程来异步处理进度可视化，一方面这样可以降低对结转任务性能的干扰，另一方面可以避免由于网络问题、配置中心暂时不可用等问题导致结转任务异常。进度可视化对于用户来说非常重要，用户在第一次定义结转任务并执行该任务的时候，进度可视化信息是用户和系统互动的唯一窗口，对用户来说是莫大的心理安慰。</p>
<p>c) 异常可视化</p>
<p>代理程序在执行数据结转任务时，会遇到各种异常信息，比如数据库URL配置错误，历史库生产库表结构不一致等，对于这些异常信息，除了在本地记录日志外，我们还将它们发送到了配置中心。将这些异常可视化，而不是让用户在大量的日志中去检索，这种方式非常便于在线问题的诊断。</p>
<p>d) 事务一致性</p>
<p>将生产库数据转到历史库本身是一个分布式的事务，在我们的方案中，不能保证数据的强一致性，比如在历史数据Insert到历史库的瞬间，用户修改了生产库的数据，我们的方案不会检测这种变化，会导致用户的修改并不会反映到历史库中，造成数据不一致。虽然在生产库中删除历史数据时，可以增加强一致性的校验，以解决这种问题，但是这样会对生产库造成一定的压力，同时考虑到这种情况发生的概率极低，因此并没有进行特殊处理。</p>
<p>历史数据Insert到历史库后，可能由于某种异常导致生产库执行Delete操作时失败，此时会造成数据冗余(生产库和历史库存在相同数据)。对于这种问题，我们的方案是利用Redo Log(重做日志)机制，在结转任务重新执行时根据Redo Log恢复异常现场，纠正异常数据。</p>
<p>e) 结转数据的回滚</p>
<p>我们提供了一个数据回滚功能，可以将已经结转到历史库的数据逆向回滚到生产库，用户可以配置Where条件精确指定需要回滚的数据。有些特殊情况，业务上需要对已经结转的历史数据进行修改，该功能主要用于处理这种情况。同时在测试阶段，我们可以通过该功能快速恢复测试数据，方便对数据结转平台的测试。</p>
<p>f) 代理程序的自动升级</p>
<p>代理程序和配置中心本质上是一种典型的C/S(客户端/服务端)结构，客户端是多实例部署，服务器端是集群部署，为了系统能够平滑地进行升级，我们需要对客户端的版本进行统一管理，同时我们提供了代理程序的自动升级功能，系统管理员可以通过配置中心对代理程序部署实例进行升级。自动升级功能，统一了代理程序的版本，使得我们可以不用被兼容性问题羁绊，是我们能够进行快速迭代开发有力支撑。</p>
<p>本文作者：王宝令、者文明</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 07:27:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>OLTP类系统数据结转最佳实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgKVP3M.html" rel="bookmark">Cassandra数据模型设计最佳实践（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文是Cassandra数据模型设计第一篇(全两篇),该系列文章包含了eBay使用Cassandra数据模型设 计的一些实践.其中一些最佳实践我们是通过社区学到的,有些对我们来说也是新知识,还有一些仍然 具有争议性,可能在要通过进一步的实践才能从中获益. 本文中,我将会讲解一些基本的实践以 及一个详细的例子.即使你不了解Cassandra,也应该能理解下面大多数内容. 说说Cassandra在 ebay的使用情况 我们尝试使用Cassandra已经超过1年时间了.Cassandra现在正在服务一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QJynp.html" rel="bookmark">SQL Server系统数据库备份最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server系统数据库备份最佳实践 首先了解主要的系统数据库: master 包含登录信息和其他数据库的核心信息 msdb 存储作业.操作员.警报.备份还原历史.数据库邮件信息等等. model 所有新数据库的模型,如果希望新数据库都有某些对象,可以在这里创建. tempdb sql server重启时重建,所以不需要备份 除了以上四种,其实还有一个数据库:Resource 从2005就引入的,一个只读.隐藏的数据库,包含所有在sql server中的系统对象.由于SQL SERV			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlK5VOb.html" rel="bookmark">2017年度TOP 10大数据应用最佳实践 案例征集活动最新启动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2017年5月18日上午,CCF大数据专家委员会召开新闻会,正式发布和启动了&quot;2017年度TOP10大数据应用最佳实践案例征集&quot;活动. CCF大数据专家委员会副秘书长.北京启明星辰信息技术有限公司首席战略官潘柱廷(左),中国科学院计算技术研究所副研究员查礼(右) 发布会上,CCF大数据专家委员会副秘书长.北京启明星辰信息技术有限公司首席战略官潘柱廷,中国科学院计算技术研究所副研究员查礼代表活动发起方,向现场数十家记者阐述了2017年大数据技术发展的现状及未来趋势,并就本次最佳实践案例征			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3253Nz.html" rel="bookmark">优云软件数据专家最佳实践：数据挖掘与运维分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这份研究报告,作者是优云软件数据专家陈是维,在耗时1年时间制作的一份最佳实践,今天和大家分享下,关于&lt;数据采矿和运维分析&gt;,共同探讨~ 数据挖掘(Data Mining)是从大量数据中提取或&quot;挖掘&quot;知识. 广义数据挖掘:数据挖掘是从存放在数据库.数据仓库或其它信息库中的大量数据挖掘有趣知识的过程. 数据挖掘技术侧重:1)概率与数理统计 2)数据库技术 3)人工智能技术 4)机器学习. 1. 数据清理:消除噪音或不一致数据 2. 数据集成:多种数据源可以组合在一起 3. 数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Jodkp.html" rel="bookmark">云箱科技符全：数据中心最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				云箱科技符全:非常感谢今天有这么多嘉宾来云基地参观,首先我代表云基地,代表天地云箱科技有限公司,向大家表示热烈的欢迎.今天主会场的会讲的是云计算,但是云计算里面我们很多人都在讲数据中心,为什么联系这么密切,大家肯定有多人做云计算,也有很多做数据中心的人,这两个行业的联系,在美国就是一个特别的明显例子.去年的统计,美国去年用电量,2%是用在IT设备上,所以云计算规模不断扩大的时候,他对于数据和耗电需求是特别大,去年IT行业90%的数据都是在这三两年产生的.到了云计算大家很多人也用微博.人人网,或者			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx24L7z.html" rel="bookmark">艾特网能创新节能技术再获大奖 引领绿色数据中心最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由中国电子节能技术协会主办,数据中心节能技术委员会和香港雅式展览集团联合承办的&quot;2016中国数据中心节能技术大会&quot;于2016年11月16日在北京新世纪日航饭店圆满举办.会议展示了国内数据中心行业节能技术创新成果,并邀请业内顶级专家解读国家政策.新标准.新技术.新应用.节能改造新思路等方面的内容,分享数据中心的节能技术趋势和实践经验. 艾特网能多项数据中心创新节能技术亮相 深圳市艾特网能技术有限公司(以下简称:艾特网能),作为数据中心基础设施完整解决方案的优秀民族品牌专业厂商,受邀参加此			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12eYrp.html" rel="bookmark">简析十大云部署最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				根据IT业贸易协会CompTIA的报告显示,如今,有80%的企业都声称在使用某种形式的云解决方案,这些方案既有可以按需启用的虚拟机,也有很容易购买.很容易使用的应用.&quot; 趋势科技客户解决方案部经理Laura Maio认为,目前有三大重要趋势在推动着云的使用和部署. 第一趋势是企业将公有云作为其内部环境的一种自然延伸. 第二趋势则是企业的非IT业务部门利用公有云可以更快捷地访问服务器和存储资源. 第三,企业的IT部门本身也有压力,需要构建安全的.功能类似公有云的私有云环境,以便从公有云提供商那里重			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN1gB4b.html" rel="bookmark">海量实时计算&plus;OLTP&plus;OLAP DB设计 - 阿里云&lpar;RDS、HybridDB&rpar; for PostgreSQL最佳实践 - 泛电网系统应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , 国家电网 , 电表 , 余额 , 流式计算 , 状态监测 , 上下文相关 背景 电网系统是一个关系民生,又非常典型的传统系统,虽然传统,量可不小.在互联网化(物联网化)的今天,有很多值得借鉴和思考的点供给其他相关系统参考. 每个省份大概有亿级户电表,最大的地市可能有千万户级别. 以往我们电费是怎么交的呢?我们小区是两个月交一次,也就是说先消费,再付款的方式.这么说起来电网真的是很仁义啊,现在哪有这么多先消费再付款的呀.移动话费.家庭宽带.天然气等等,都是充值后使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqO4ORz.html" rel="bookmark">免费制冷：数据中心节能系统最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用节能系统配合免费冷却方法来降低能源开销,一直是数据中心的热点话题.任何时间,如果可以关掉空调单元或减少冷水机组的使用,可以减少服务 器所产生的热量,这不仅能降低运营开销,还可以延长冷却设备的使用寿命,降低损耗.North American Access Technologies,是一家经营数据中心设计与咨询业务公司,Julius Neudorfer是其首席技术官,将给我们介绍一些关于数据中心节能系统最佳实践的内容. 问题:节能系统与&quot;免费冷却&quot;对企业级数据中心的远景是怎样的? Ju			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwln5b.html" rel="bookmark" class="title">Oracle数据库备份技巧</a>
					<div>
						  利用下面的列出的技巧来确保你不会在每周一次的数据库备份过程中忘记关键步骤. 每周一次备份主数据库.如果你创建.修改或者停止一个数据库,添加新的SQL Server消息,添加或者停止连接服务器,或者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgw4AM.html" rel="bookmark" class="title">可以触发点击事件并变色的UILabel</a>
					<div>
						可以触发点击事件并变色的UILabel 谁说UILabel不能够当做button处理点击事件呢?今天,笔者就像大家提供一个改造过的,能够触发点击事件并变色的UILabel:) 效果图: 还能当做计时器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr1YOb.html" rel="bookmark" class="title">以Procmail-Gateway过滤寄出信件病毒&lpar;1&rpar;</a>
					<div>
						在安装Procmail及Sanitizer后,系统都只能处理寄进服务器内的信件,无法处理利用邮件服务器来寄出病毒信,因此在安装Procmail-Gateway修改sendmail.cf后可以在服务器寄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5466M.html" rel="bookmark" class="title">网站标题&OpenCurlyDoubleQuote;不跑题&rdquo; SEO优化顺风前行</a>
					<div>
						还记得小学老师的那一句话:张强,您的作文标题又跑题了.至今这句话依然回味在我头海中,从网站建立那一刻开始:老师这句话就荡漾在我的眼前,作文标题不跑题与网站标题不跑题难道不是一个道理吗? 作文标题跑题那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDOPBp.html" rel="bookmark" class="title">网站seo优化过程中的致命细节</a>
					<div>
						大家都知道网站在做seo优化的过程中要把握的一些重点,诸如内容的更新.外链的建设等等.但是有一些优化过程中的小细节也决不能忽视,这些小细节虽然并不能直接的为网站带来多好的排名,或者多少的流量,但是往往 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmvjDz.html" rel="bookmark" class="title">JSF Struts Spring Hibernate整合</a>
					<div>
						JSF1.1+Struts2.1+Spring2.0+Hibernate3.1 图示: JSF1.1 Jar包 : MyFaces1.1 Jar包: Struts2.1 Jar包: Spring2.0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balevJz.html" rel="bookmark" class="title">Linux的path&lowbar;alloc函数</a>
					<div>
						#include &quot;apue.h&quot; #include &lt;errno.h&gt; #include &lt;limits.h&gt; #ifdef PATH_MAX stati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4q1Vp.html" rel="bookmark" class="title">jQuery切换所有复选框选中状态的方法</a>
					<div>
						  本文实例讲述了jQuery切换所有复选框选中状态的方法.分享给大家供大家参考.具体如下: 这段代码非常简单实用,通过链接切换所有checkbox是否选中 ? 1 2 3 4 5 6 var tog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjLYnp.html" rel="bookmark" class="title">WPS论文如何添加目录</a>
					<div>
						  WPS论文如何添加目录           本文图文详述了WPS论文排版教程六:如何添加目录. 操作步骤 1.准备好WPS文档. 2.为文档标题设置样式. 3.选择适合的多级编号. 4.点击引用选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N52rM.html" rel="bookmark" class="title">jar-如何用java生成pdf文件</a>
					<div>
						问题描述 如何用java生成pdf文件 就是写一个方法,把一个html文件打印成pdf文件,我按照网上的试了,用了itext,结果不能显示中文,求大神帮忙,最好给出相应的jar包 解决方案 参考:ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamWEJb.html" rel="bookmark" class="title">ios-高手求助：传递NSError到方法中</a>
					<div>
						问题描述 高手求助:传递NSError到方法中 有一个方法,参数: (void(^)(NSError*))errorCall; 需要传递errorCall值: -(void)message{ exam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1raY5p.html" rel="bookmark" class="title">2013苹果发布会细节大曝光</a>
					<div>
						美国时间9月10日上午9点(北京时间9月11日凌晨1点),苹果公司将正式举办2013秋季新品发布会.至于发布会的内容,他们并没有透露,今天一组来自sonnydickson网站的第五代iPad高清大图曝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0kjKM.html" rel="bookmark" class="title">mysqldump 参数--lock-tables浅析</a>
					<div>
						mysqldump有一个参数--lock-tables,以前对这个参数也没有详细了解过,直到上次有个网友问&quot;参数lock-tables 是一次性锁定当前库的所有表,还是锁定当前导出表?&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlYv7p.html" rel="bookmark" class="title">物联网如何提升员工工作效率和安全性？</a>
					<div>
						英特尔与霍尼韦尔共同合作,开发了一款基于物联网的安全解决方案,这不仅可以防止员工在工业工作场所中发生意外,还有助于提升员工的工作效率. 工业工作场所和建筑工地的安全风险通常都比较高.此外,消防员或其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZB7mz.html" rel="bookmark" class="title">这个错误是什么意思</a>
					<div>
						问题描述 5s以下会编译报错 解决方案 已解决  不知道原因 在appdelegate中加入这段话 编译通过 extern&quot;C&quot;{    size_t fwrite$UNIX200 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA5yZM.html" rel="bookmark" class="title">今年艺考最低分数划定 两个网站可查询</a>
					<div>
						商报记者 李双全 重庆商报讯 2013年普通高等学校招生艺术类专业考试成绩最低控制分数线划定.昨日,市教育考试院公布了最低控制分数线.考生可以登录重庆市教育考试院门户网站(http://www.cqk ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqwPWb.html" rel="bookmark" class="title">jqgrid 显示问题-jqGrid 分页查询后，有一个层把我的页面遮罩了，请问是什么问题</a>
					<div>
						问题描述 jqGrid 分页查询后,有一个层把我的页面遮罩了,请问是什么问题 解决方案 设置背景色为白色 解决方案二: 你早上那个问题解决了.你上面那个问题一般得调css ,你说下面没有遮罩,有2种可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YZVPz.html" rel="bookmark" class="title">《Node&period;js区块链开发》&mdash;&mdash;1&period;4　加密货币可靠吗</a>
					<div>
						1. 1.4 加密货币可靠吗 从上面的讨论中,我们可以了解加密货币是怎么回事了,但是你可能仍然会怀疑加密货币的实用性,它真的可靠吗?这是最初很多人都会问的问题.结论当然是可靠的,但是要解释清楚为什么, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoRoAM.html" rel="bookmark" class="title">nsdate-ios-获取一星期的始末日期</a>
					<div>
						问题描述 ios-获取一星期的始末日期 代码: NSCalendar *calendar = [NSCalendar currentCalendar]; NSInteger weekNumber =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmR0qp.html" rel="bookmark" class="title">市消协列出五类&OpenCurlyDoubleQuote;霸王条款&rdquo;</a>
					<div>
						今年3月初,市消协对社会公开征集不公平的格式合同条款,也就是消费者常说的&quot;霸王条款&quot;.昨天,记者从市消协获悉,截止到今年4月30日,市消协在征集不公平格式合同条款活动中,共收到消费 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPllXrp.html" rel="bookmark" class="title">实例详解Linxu中df命令&lowbar;linux shell</a>
					<div>
						df 即&quot;可用磁盘&quot;disk free,用于显示文件系统的磁盘使用情况.默认情况下 df 命令将以每块 1K 的单位进行显示所有当前已挂载的文件系统,如果你想以人类易读的格式显示  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWDVlz.html" rel="bookmark" class="title">云服务发布-云服务Web角色在发布时选择订阅没有导入选项</a>
					<div>
						问题描述 云服务Web角色在发布时选择订阅没有导入选项 已下载发布文件 解决方案 先上面添加一个账户吧?具体问下客服.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNoE5p.html" rel="bookmark" class="title">net中用基于模型和接口的T4来生成RESTful服务</a>
					<div>
						关键要点 许多REST服务中都包含重复的模式: 如果能自动生成这些模式相关的代码就可以节省很多时间: Visual Studio的T4和EnvDTE具有强大的生成代码功能,不需要更多工具辅助: 也可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvXR1M.html" rel="bookmark" class="title">android读取大图片并缓存</a>
					<div>
						http://blog.csdn.net/liliang497/article/details/7221110 最近开发电视版的云存储应用,要求&quot;我的相册&quot;模块有全屏预览图片的功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdXY9b.html" rel="bookmark" class="title">WINDOWS 2008 R2 IIS错误，求大神，在先急等！</a>
					<div>
						问题描述 IIS应用池在网站访问的时候自动停止,查看了WINDOWS的应用日志,在应用程序中出现如下2个错误:1..日志名称:Application来源:Microsoft-Windows-IIS-W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRx6jz.html" rel="bookmark" class="title">Android自定义viewgroup 使用adapter适配数据（6）&lowbar;Android</a>
					<div>
						在自定义viewgroup(5):http://www.jb51.net/article/100639.htm的基础上,添加使用adapter来适配数据,这样更加的方便,这里只是使用adapter适配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GPklM.html" rel="bookmark" class="title">《设计原本&mdash;计算机科学巨匠Frederick P&period; Brooks的反思》一一3&period;9   那又如何？我们的设计过程模型真的那么事关紧要吗</a>
					<div>
						3.9 那又如何?我们的设计过程模型真的那么事关紧要吗 为什么就过程模型讲了这么多?我们或是别人用来进行设计过程的思维真的会影响设计本身吗?我认为的确是这样的. 并非所有的设计思想家都同意我的观点.剑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPBd6p.html" rel="bookmark" class="title">PostgreSQL子查询优化详解</a>
					<div>
						1.2.2 PostgreSQL 1.2.2.1 S6 语句 查看查询执行计划,子查询被优化(采用物化的方式,使得子查询结果被缓存,既子查询只执行一次). postgres=# EXPLAIN SEL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXN9jyb.html" rel="bookmark" class="title">上海电视传媒公司&OpenCurlyDoubleQuote;制播分离&rdquo;探索之路完成突破性尝试</a>
					<div>
						2009年初,国产卡通形象&quot;喜羊羊&quot;从电视荧屏跃上了电影银幕,创下8500万元人民币的惊人票房.这部国产动画影片热映的背后,蕴藏着中国电视机构正在进行中的&quot;制播分离&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgW0ZBM.html" rel="bookmark" class="title">分享：网站快照回档解决过程</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 11月1日起来,跟往前一样,打开百 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
